﻿using System;
using System.Collections.Generic;
using CoreGraphics;
using Foundation;
using Syncfusion.SfSchedule.iOS;
using UIKit;

namespace SfSchedule_Xamarin_iOS
{
	public partial class ViewController : UIViewController
	{

		SFSchedule schedule;

		protected ViewController(IntPtr handle) : base(handle)
		{
			// Note: this .ctor should not contain any initialization logic.
		}

		public override void ViewDidLoad()
		{
			base.ViewDidLoad();
			// Perform any additional setup after loading the view, typically from a nib.

			schedule = new SFSchedule();
			schedule.Delegate = new ScheduleDelegate();
			schedule.Appointments = CreateAppointments();
			schedule.ScheduleView = SFScheduleView.SFScheduleViewMonth;
			View = schedule;
		}

		NSMutableArray CreateAppointments()
		{
			NSDate today = new NSDate();
			NSCalendar calendar = NSCalendar.CurrentCalendar;
			// Get the year, month, day from the date
			NSDateComponents components = calendar.Components(
				NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

			// Set the hour, minute, second
			components.Hour = 10;
			components.Minute = 0;
			components.Second = 0;
			NSDate startDate = calendar.DateFromComponents(components);
			// Get the year, month, day from the date
			NSDateComponents endDateComponents = calendar.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

			// Set the hour, minute, second
			endDateComponents.Hour = 12;
			endDateComponents.Minute = 0;
			endDateComponents.Second = 0;
			NSDate endDate = calendar.DateFromComponents(endDateComponents);
			ScheduleAppointment appointment = new ScheduleAppointment();
			appointment.StartTime = startDate;
			appointment.EndTime = endDate;
			appointment.Subject = new NSString("Jeni's B'Day Celebration");
			appointment.AppointmentBackground = UIColor.FromRGB(0xA2, 0xC1, 0x39);
			NSDateComponents components1 = calendar.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

			// Set the hour, minute, second
			components1.Hour = 11;
			components1.Minute = 0;
			components1.Second = 0;
			components1.Day = components1.Day + 1;
			NSDate startDate1 = calendar.DateFromComponents(components1);
			// Get the year, month, day from the date
			NSDateComponents endDateComponents1 = calendar.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);

			// Set the hour, minute, second
			endDateComponents1.Hour = 13;
			endDateComponents1.Minute = 30;
			endDateComponents1.Second = 0;
			endDateComponents1.Day = endDateComponents1.Day + 1;
			NSDate endDate1 = calendar.DateFromComponents(endDateComponents1);
			ScheduleAppointment appointment1 = new ScheduleAppointment();
			appointment1.StartTime = startDate1;
			appointment1.EndTime = endDate1;
			appointment1.Subject = new NSString("Checkup");
			appointment1.AppointmentBackground = UIColor.FromRGB(0xD8, 0x00, 0x73);
			NSMutableArray appCollection = new NSMutableArray();
			appCollection.Add(appointment);
			appCollection.Add(appointment1);
			return appCollection;
		}

		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
			// Release any cached data, images, etc that aren't in use.
		}
	}

	public class ScheduleDelegate : SFScheduleDelegate
	{

		public override void didMonthcellLoaded(SFMonthCellLoaded monthCellLoaded)
		{
			NSDate date = monthCellLoaded.Date;
			NSDateFormatter dateFormat = new NSDateFormatter();
			dateFormat.DateFormat = "EEEE";
			string monthName = dateFormat.ToString(date);

			if (monthCellLoaded.IsToday)
			{
				monthCellLoaded.CellStyle.TextColor = UIColor.FromRGB(238, 199, 43);
			}

			if (((monthName == "Sunday") || (monthName == "Saturday")))
			{
				monthCellLoaded.CellStyle.TextColor = UIColor.Red;
			}
			if (monthCellLoaded.IsPreviousMonthDate)
			{
				if (((monthName == "Sunday") || (monthName == "Saturday")))
				{
					monthCellLoaded.CellStyle.TextColor = UIColor.Red;
				}
				else {
					monthCellLoaded.CellStyle.TextColor = UIColor.Gray;
				}
			}
			if (monthCellLoaded.IsNextMonthDate)
			{
				if (((monthName == "Sunday") || (monthName == "Saturday")))
				{
					monthCellLoaded.CellStyle.TextColor = UIColor.Red;
				}
				else {
					monthCellLoaded.CellStyle.TextColor = UIColor.Gray;
				}
			}
		}
	}
}
